/**
 * map representation
 */
export class Vault {
    constructor(name = "") {
        this.name = name;
        this.storage = {};
        /**
         * set key-value pair in storage
         * @param {String} key
         * @param {*} value
         */
        this.set = (key, value) => {
            this.storage[key] = value;
        };
        /**
         * return element from storage
         * @param {String} key
         * @returns element (ref) or undefined
         */
        this.get = (key) => {
            return this.storage[key];
        };

        /**
         *
         * @param {String} key
         * @returns true/false
         */
        this.existsKey = (key) => {
            return Object.keys(this.storage).includes(key);
        };

        /**
         * remove key from storage
         * @param {String} key 
         * @returns true/false
         */
        this.del = (key) => {
            return delete this.storage[key];
        }

        /**
         * clears storage
         */
        this.clear = () => {this.storage = {}}

        /**
         *
         * @param {*} value
         * @returns found value (ref) or false
         */
        this.find = (value) => {
            let t = Object.keys(this.storage);
            for (const i of t) {
                if (this.storage[i] === value) return this.storage[i];
            }
            return false;
        };

        /**
         * run 'for' loop through all storage and call 'fn(storage_element)'
         * @param {Function} fn 
         */
        this.forAll = (fn) => {
            let keys = Object.keys(this.storage);
            for (const i of keys) {
                fn(this.storage[i]);
            }
        };
    }
}